VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cShellVersion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'   Module          : cShellVersion
'   Description     : Returns the Shell DLL Versions
'   Author          : C. Eswar Santhosh
'   Last Updated    : 14th February, 2000.
'   Notes           : Many Shell DLLs export the function DllGetVersion. These include Shell32.dll, ShlWapi.dll, Comctl32.dll
'                     ShDocVw.dll etc.,
'
'   Copyright Info  :
'
'   This Class module is provided AS-IS. This Class module can be used as a part of a compiled
'   executable whether freeware or not. This Class module may not be posted to any web site
'   or BBS or any redistributable media like CD-ROM without the consent of the author.
'
'   Web Site : http://eswar_santhosh.tripod.com
'
'   e-mail   : eswar_santhosh@yahoo.com
'
'   Revision History :
'
'
'-------------------------------------------------------------------------------------------------------------

Option Explicit
                                                    
'
' API Constants
'
Private Const DLLVER_PLATFORM_WINDOWS As Long = &H1     ' Windows 9x
Private Const DLLVER_PLATFORM_NT As Long = &H2          ' Windows NT
Private Const NOERROR As Long = 0                       ' Result

' Format Message Constants
Private Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200
Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000

' For Version Information
Private Const MAX_PATH As Long = 260
Private Const VOS_NT As Long = &H40000

'
' API Types
'
Private Type DLLVERSIONINFO
    cbSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformID As Long
End Type

' Supported by Version 5.0 or higher of Shlwapi.dll
Private Type DLLVERSIONINFO2
    Info1 As DLLVERSIONINFO
    dwFlags As Long             ' Currently, reserved and must be set to zero.
    ullVersion As Currency      ' Encoding of the 4 Bytes : [Major] [Minor] [Build] [QFE]
End Type

' For Older guys, this is the one that works
Private Type VS_FIXEDFILEINFO
        dwSignature As Long
        dwStrucVersion As Long         '  e.g. 0x00000042 = "0.42"
        dwFileVersionMS As Long        '  e.g. 0x00030075 = "3.75"
        dwFileVersionLS As Long        '  e.g. 0x00000031 = "0.31"
        dwProductVersionMS As Long     '  e.g. 0x00030010 = "3.10"
        dwProductVersionLS As Long     '  e.g. 0x00000031 = "0.31"
        dwFileFlagsMask As Long        '  = 0x3F for version "0.42"
        dwFileFlags As Long            '  e.g. VFF_DEBUG Or VFF_PRERELEASE
        dwFileOS As Long               '  e.g. VOS_DOS_WINDOWS16
        dwFileType As Long             '  e.g. VFT_DRIVER
        dwFileSubtype As Long          '  e.g. VFT2_DRV_KEYBOARD
        dwFileDateMS As Long           '  e.g. 0
        dwFileDateLS As Long           '  e.g. 0
End Type

'
' API Declarations (This direct declarations avoid using the unreliable CreateThread to call the function)
'
Private Declare Function ShellVersion Lib "Shell32" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO) As Long

Private Declare Function ShellVersion2 Lib "Shell32" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO2) As Long

Private Declare Function ComCtlVersion Lib "ComCtl32" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO) As Long

Private Declare Function ComCtlVersion2 Lib "ComCtl32" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO2) As Long

Private Declare Function ShlWapiVersion Lib "ShlWapi" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO) As Long

Private Declare Function ShlWapiVersion2 Lib "ShlWapi" _
Alias "DllGetVersion" (VerInfo As DLLVERSIONINFO2) As Long

Private Declare Function FormatMessage Lib "kernel32" Alias _
"FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, _
ByVal dwMessageId As Long, ByVal dwLanguageId As Long, _
ByVal lpBuffer As String, ByVal nSize As Long, _
Arguments As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(Destination As Any, Source As Any, ByVal Length As Long)

' For the Classic approach
Private Declare Function GetSystemDirectory Lib "kernel32" _
Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) _
As Long

Private Declare Function GetFileVersionInfoSize Lib "version.dll" _
Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) _
As Long

Private Declare Function GetFileVersionInfo Lib "version.dll" _
Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, _
ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Any) As Long

' The win32api.txt declaration is wrong.
Private Declare Function VerQueryValue Lib "version.dll" _
Alias "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, _
lplpBuffer As Any, _
puLen As Long) As Long

'
' Enums
'
Public Enum ShellLibrary
    libShell
    libCommonControls
    libShellLightWeight
End Enum

Public Enum DLLPlatform
    dllWindows
    dllWindowsNT
End Enum

'
' Local Variables
'
Dim m_Major As Long             ' Major Version
Dim m_Minor As Long             ' Minor Version
Dim m_BuildNumber As Long       ' Build Number
Dim m_QFEVersion As Long        ' QFE Number
Dim m_PlatformID As DLLPlatform ' Platform for which the DLL was written

Public Sub GetLibVersion(Library As ShellLibrary)
Attribute GetLibVersion.VB_Description = "Gets the Shell Library Version"
'
' First Try it with the Old version, if there is support for DLLVERSIONINFO2
' Get Additional details.
'
'On Error Resume Next

Dim vDLL As DLLVERSIONINFO, v5DLL As DLLVERSIONINFO2
Dim apiRetVal As Long, memPtr As Long

' Initialize the structures
vDLL.cbSize = Len(vDLL)
v5DLL.Info1.cbSize = Len(v5DLL)

m_Major = 0
m_Minor = 0
m_BuildNumber = 0
m_QFEVersion = 0

If Library = libShell Then
    apiRetVal = ShellVersion(vDLL)
ElseIf Library = libCommonControls Then
    apiRetVal = ComCtlVersion(vDLL)
ElseIf Library = libShellLightWeight Then
    apiRetVal = ShlWapiVersion(vDLL)
End If

If Err.Number <> 0 Then
    ' Instead of trapping an error here, nothing stops you from using the politically
    ' correct LoadLibrary, followed by GetProcAddress to check if DllGetVersion is
    ' actually exported. But, lazy guys write less code.
    If Err.Number = 453 Then        ' Could not find entry point in DLL
        '
        ' Let's try the Classic method. This is just minimal code. If you need
        ' a full fledged Version Information extractor, you need to visit Karl E. Peterson's samples page
        ' at http:\\www.mvps.org\vb\
        '
        If Library = libShell Then
            GetVersionClassic ("shell32.dll")
        ElseIf Library = libCommonControls Then
            GetVersionClassic ("comctl32.dll")
        ElseIf Library = libShellLightWeight Then
            GetVersionClassic ("shlwapi.dll")
        End If
    Else                            ' Some other Error
        On Error GoTo 0
        Err.Raise Err.Number, App.Title & ".Shell DLL Version", Err.Description, Err.HelpFile, Err.HelpContext
    End If
End If

If apiRetVal <> NOERROR Then
    Err.Raise 28000, App.Title & ".Shell Version", APIError(Err.LastDllError)
    Exit Sub
End If
        
If vDLL.dwMajorVersion >= 5 Then
'
' Get More Information
'
    If Library = libShell Then
        apiRetVal = ShellVersion2(v5DLL)
    ElseIf Library = libCommonControls Then
        apiRetVal = ComCtlVersion2(v5DLL)
    ElseIf Library = libShellLightWeight Then
        apiRetVal = ShlWapiVersion2(v5DLL)
    End If
        
    If apiRetVal <> NOERROR And Err.LastDllError <> 0 Then
        Err.Raise 28000, App.Title & ".Shell Version", APIError(Err.LastDllError)
        Exit Sub
    
    ElseIf apiRetVal = NOERROR Then
        ' Retrieve Version Information from the ulonglong Field
        memPtr = VarPtr(v5DLL.ullVersion)
                
        CopyMemory m_Major, ByVal memPtr + 6, 2&
        CopyMemory m_Minor, ByVal memPtr + 4, 2&
        CopyMemory m_BuildNumber, ByVal memPtr + 2, 2&
        CopyMemory m_QFEVersion, ByVal memPtr, 2&
    
        m_PlatformID = IIf(v5DLL.Info1.dwPlatformID = DLLVER_PLATFORM_NT, dllWindowsNT, dllWindows)
  Else
    m_Major = vDLL.dwMajorVersion
    m_Minor = vDLL.dwMinorVersion
    m_BuildNumber = vDLL.dwBuildNumber
    m_QFEVersion = 0
    m_PlatformID = IIf(vDLL.dwPlatformID = DLLVER_PLATFORM_NT, dllWindowsNT, dllWindows)
  
  End If
  
Else
    m_Major = vDLL.dwMajorVersion
    m_Minor = vDLL.dwMinorVersion
    m_BuildNumber = vDLL.dwBuildNumber
    m_QFEVersion = 0
    m_PlatformID = IIf(vDLL.dwPlatformID = DLLVER_PLATFORM_NT, dllWindowsNT, dllWindows)
End If

End Sub

Public Property Get MajorVersion() As Long
Attribute MajorVersion.VB_Description = "Returns the Major Version of the Shell DLL"
    MajorVersion = m_Major
End Property

Public Property Get MinorVersion() As Long
Attribute MinorVersion.VB_Description = "Returns the Minor Version of the Shell DLL"
    MinorVersion = m_Minor
End Property

Public Property Get BuildNumber() As Long
Attribute BuildNumber.VB_Description = "Build Number of the Shell DLL"
    BuildNumber = m_BuildNumber
End Property

Public Property Get QFEVersion() As Long
Attribute QFEVersion.VB_Description = "QFE Version of the Shell DLL if supported."
    QFEVersion = m_QFEVersion
End Property

Public Property Get Platform() As DLLPlatform
    Platform = m_PlatformID
End Property

Private Sub GetVersionClassic(ByVal LibName As String)
'
' In this case, these DLLs have only one folder where they reside, the System Folder
'
Dim mBuffer As String, mVerSize As Long, Dummy As Long, mVerInfo() As Byte
Dim mFixedFileInfo As VS_FIXEDFILEINFO, ptrBufferAddress As Long, lenBlock As Long

mBuffer = Space$(MAX_PATH)

GetSystemDirectory mBuffer, Len(mBuffer)

mBuffer = Left$(mBuffer, InStr(mBuffer, Chr$(0)) - 1)
mBuffer = mBuffer & "\" & LibName

'
' Why do we need this ? Because, there was no Shlwapi before IE4.
'
If Dir(mBuffer) = "" Then
    Err.Raise 28001, App.Title & ".Shell DLL Version", "Shell DLL File was not found : " & LibName
    Exit Sub
End If

' Dummy will be set to zero by the function
mVerSize = GetFileVersionInfoSize(mBuffer, Dummy)

If mVerSize = 0 Then      ' This error will *never* happen
    Err.Raise 28002, App.Title & ".Shell DLL Version", "Version Information Resource not found"
End If

ReDim mVerInfo(mVerSize)

GetFileVersionInfo mBuffer, 0&, mVerSize, mVerInfo(0)

' Request the Root Block which returns a VS_FIXED_FILE_INFO Structure
VerQueryValue mVerInfo(0), "\", ptrBufferAddress, lenBlock

' Now ptrBufferAddress contains the Address of the VS_FIXED_FILE_INFO Block.
CopyMemory mFixedFileInfo, ByVal ptrBufferAddress, LenB(mFixedFileInfo)

' We are interested in the File Version members only.
' Get the File Version from them
CopyMemory m_Major, ByVal VarPtr(mFixedFileInfo.dwFileVersionMS) + 2, 2&
CopyMemory m_Minor, ByVal VarPtr(mFixedFileInfo.dwFileVersionMS), 2&
CopyMemory m_BuildNumber, ByVal VarPtr(mFixedFileInfo.dwFileVersionLS) + 2, 2&
CopyMemory m_QFEVersion, ByVal VarPtr(mFixedFileInfo.dwFileVersionLS), 2&

' The other thing is to get the Platform ID.
m_PlatformID = IIf(mFixedFileInfo.dwFileOS = VOS_NT, dllWindowsNT, dllWindows)

End Sub

Private Function APIError(ByVal ErrNumber As Long) As String
'
' Returns the Error Message for the API Error.
'
Dim strMessage As String, lenMessage As Long

strMessage = Space$(1024)
lenMessage = FormatMessage(FORMAT_MESSAGE_IGNORE_INSERTS Or FORMAT_MESSAGE_FROM_SYSTEM, _
vbNull, ErrNumber, 0, strMessage, Len(strMessage), vbNull)

If lenMessage > 0 Then APIError = Left$(strMessage, lenMessage)
End Function
